<template>
  <el-card class="box-card" shadow="always">
    <div slot="header" class="clearfix">
      <span>{{ title }}</span>
      <el-button-group style="float: right;">
        <el-button size="mini" icon="el-icon-plus" round :loading="loadingOptions.loading" :disabled="loadingOptions.isDisabled" @click="submitForm">{{ loadingOptions.loadingText }}</el-button>
        <el-button size="mini" icon="el-icon-back" round @click="showCard">返回</el-button>
      </el-button-group>
    </div>
    <div class="body-wrapper">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="规则名称" prop="ruleName">
          <el-input v-model="form.ruleName" placeholder="请输入规则名称" />
        </el-form-item>
        <el-form-item label="规则级别" prop="ruleLevel">
          <el-radio-group v-model="form.ruleLevel">
            <el-radio
              v-for="dict in ruleLevelOptions"
              :key="dict.id"
              :label="dict.itemText"
            >{{ dict.itemValue }}</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="数据源" prop="ruleSourceId">
          <el-select v-model="form.ruleSourceId" placeholder="请选择数据源" @change="sourceSelectChanged">
            <el-option
              v-for="source in sourceOptions"
              :key="source.id"
              :label="source.sourceName"
              :value="source.id"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="数据表" prop="ruleTableId">
          <el-select v-model="form.ruleTableId" placeholder="请选择数据表" @change="tableSelectChanged">
            <el-option
              v-for="table in tableOptions"
              :key="table.id"
              :label="table.tableName"
              :value="table.id">
              <span style="float: left">{{ table.tableName + '(' + table.tableComment + ')' }}</span>
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="核查字段" prop="ruleColumnId">
          <el-select v-model="form.ruleColumnId" placeholder="请选择核查字段" @change="columnSelectChanged">
            <el-option
              v-for="column in columnOptions"
              :key="column.id"
              :label="column.columnName"
              :value="column.id">
              <span style="float: left">{{ column.columnName + '(' + column.columnComment + ')' }}</span>
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="核查脚本" prop="ruleSql">
          <el-input v-model="form.ruleSql" type="textarea" placeholder="请输入核查脚本" />
        </el-form-item>
        <el-form-item label="状态" prop="status">
          <el-radio-group v-model="form.status">
            <el-radio
              v-for="dict in statusOptions"
              :key="dict.id"
              :label="dict.itemText"
            >{{ dict.itemValue }}</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
    </div>
  </el-card>
</template>

<script>
import { addCheckRule } from '@/api/quality/checkrule'
import { listDataSource } from '@/api/metadata/datasource'
import { listDataTable } from '@/api/metadata/datatable'
import { listDataColumn } from '@/api/metadata/datacolumn'

export default {
  name: 'CheckRuleAdd',
  props: {
    data: {
      type: Object,
      default: function() {
        return {}
      }
    }
  },
  data() {
    return {
      title: '核查规则新增',
      // 展示切换
      showOptions: {
        data: {},
        showList: true,
        showAdd: false,
        showEdit: false,
        showDetail: false
      },
      // 保存按钮
      loadingOptions: {
        loading: false,
        loadingText: '保存',
        isDisabled: false
      },
      // 表单参数
      form: {
        ruleName: undefined,
        ruleLevel: '1',
        ruleSourceId: undefined,
        ruleSource: undefined,
        ruleTableId: undefined,
        ruleTable: undefined,
        ruleColumnId: undefined,
        ruleColumn: undefined,
        ruleSql: undefined,
        status: '1'
      },
      // 表单校验
      rules: {
        ruleName: [
          { required: true, message: '规则名称不能为空', trigger: 'blur' }
        ],
        ruleSourceId: [
          { required: true, message: '数据源不能为空', trigger: 'change' }
        ],
        ruleTableId: [
          { required: true, message: '数据表不能为空', trigger: 'change' }
        ],
        ruleColumnId: [
          { required: true, message: '核查字段不能为空', trigger: 'change' }
        ]
      },
      // 状态数据字典
      statusOptions: [],
      // 规则级别数据字典
      ruleLevelOptions: [],
      sourceOptions: [],
      tableOptions: [],
      columnOptions: []
    }
  },
  created() {
    console.log('data:' + this.data)
    this.form.ruleTypeId = this.data.ruleTypeId
    this.getDicts('sys_common_status').then(response => {
      if (response.success) {
        this.statusOptions = response.data
      }
    })
    this.getDicts('data_check_rule_level').then(response => {
      if (response.success) {
        this.ruleLevelOptions = response.data
      }
    })
    this.getDataSourceList()
  },
  methods: {
    showCard() {
      this.$emit('showCard', this.showOptions)
    },
    getDataSourceList() {
      listDataSource().then(response => {
        if (response.success) {
          this.sourceOptions = response.data
        }
      })
    },
    sourceSelectChanged(val) {
      listDataTable({ sourceId: val }).then(response => {
        if (response.success) {
          this.tableOptions = response.data
          this.columnOptions = []
          const source = this.sourceOptions.find(function(item) {
            return item.id === val
          })
          this.form.ruleSource = source.sourceName
          this.form.ruleTableId = ''
          this.form.ruleTable = ''
          this.form.ruleColumnId = ''
          this.form.ruleColumn = ''
        }
      })
    },
    tableSelectChanged(val) {
      listDataColumn({ sourceId: this.form.ruleSourceId, tableId: val }).then(response => {
        if (response.success) {
          this.columnOptions = response.data
          const table = this.tableOptions.find(function(item) {
            return item.id === val
          })
          this.form.ruleTable = table.tableName
          this.form.ruleTableComment = table.tableComment
          this.form.ruleColumnId = ''
          this.form.ruleColumn = ''
          this.form.ruleColumnComment = ''
        }
      })
    },
    columnSelectChanged(val) {
      const column = this.columnOptions.find(function(item) {
        return item.id === val
      })
      this.form.ruleColumn = column.columnName
      this.form.ruleColumnComment = column.columnComment
      this.$forceUpdate()
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          this.loadingOptions.loading = true
          this.loadingOptions.loadingText = '保存中...'
          this.loadingOptions.isDisabled = true
          addCheckRule(this.form).then(response => {
            if (response.success) {
              this.$message.success('保存成功')
              setTimeout(() => {
                // 2秒后跳转列表页
                this.$emit('showCard', this.showOptions)
              }, 2000)
            } else {
              this.$message.error('保存失败')
              this.loadingOptions.loading = false
              this.loadingOptions.loadingText = '保存'
              this.loadingOptions.isDisabled = false
            }
          }).catch(() => {
            this.loadingOptions.loading = false
            this.loadingOptions.loadingText = '保存'
            this.loadingOptions.isDisabled = false
          })
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.el-card ::v-deep .el-card__body {
  height: calc(100vh - 230px);
  overflow-y: auto;
}
</style>
